import sqlite3
from exceptions import TooMuchArgs
from typing import Any, List

class DataBase():
    def __init__(self, dbname : str, dbpath : str, primary_key : str = None, autoincrement : bool = False, **args):
        """
        The database controller and intialization.
        Parameters:
        dbname: string, the database name,
        dbpath: string, the database path,
        primary_key: string, the primary key of the database (not required),
        autoincrement: boolean, if the primary key is defined
        **args: any, the columns.
        """
        self.if_primary_key = "INTEGER PRIMARY KEY" if primary_key else None
        self.if_autoincrement = "AUTOINCREMENT" if primary_key and autoincrement == True else None
        self.dbname = dbname
        self.dbpath = dbpath
        self.primary_key = primary_key
        self.autoincrement = autoincrement
        if args >30:
            raise TooMuchArgs("You can't have more than 30 rows in your database.")
        else:
            for arg in args.values():
                self.parameters = arg
        db = sqlite3.connect(self.dbpath)
        cur = db.cursor()
        cur.execute(
            f"""
            CREATE TABLE IF NOT EXISTS {self.dbname}({primary_key} {self.if_primary_key} {self.if_autoincrement}, {self.parameters})
        """)
        return cur, db

    def insert_into(self, columns = List[str], **args : Any):
        """
        Insert values into a table.
        Parameters:
        columns: list of strings, the columns.
        **args: any, the values.
        N.B: if you have a column that is an autoinmcrement primary key, don't add it.
        """
        db = sqlite3.connect(self.dbpath)
        cur = db.cursor()
        columns = columns
        nb_params = len(args)
        params = []
        for arg in args.values():
            params.append(arg)
        if columns > 30:
            raise TooMuchArgs("You can't insert more than 30 rows in your database.")
        for col in columns:
            column = col
        
        if nb_params <= 30:
            if nb_params == 29:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 28:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 27:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 26:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 25:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 24:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 23:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 22:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 21:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 20:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 19:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 18:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 17:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 16:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 15:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 14:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 13:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 12:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 11:
                qmarks = "?,?,?,?,?,?,?,?,?,?,?"
            if nb_params == 10:
                qmarks = "?,?,?,?,?,?,?,?,?,?"
            if nb_params == 9:
                qmarks = "?,?,?,?,?,?,?,?,?"
            if nb_params == 8:
                qmarks = "?,?,?,?,?,?,?,?"
            if nb_params == 7:
                qmarks = "?,?,?,?,?,?,?"
            if nb_params == 6:
                qmarks = "?,?,?,?,?,?"
            if nb_params == 5:
                qmarks = "?,?,?,?,?"
            if nb_params == 4:
                qmarks = "?,?,?,?"
            if nb_params == 3:
                qmarks = "?,?,?"
            if nb_params == 2:
                qmarks = "?,?"
            if nb_params == 1:
                qmarks = "?"
        elif nb_params == 30:
            qmarks = "?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?"
        else:
            raise TooMuchArgs()
            
        cur.execute(f"INSERT INTO {self.dbname}({column}) VALUES({qmarks})", params)
        db.commit()
        return cur, db
        
